// programme philosophe.c
#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>

#define N 5
// nombre de philosophes
#define G (i + 1) % N
// fourchette gauche du philosophe i
#define D i
// fourchette droite du philosophe i
#define libre 1
#define occupe 0
static int fourch[N];

sem_t mutex;

static void *philosophe(void *num)
{
	int i = *(int *)num, nb = 2;
	while (nb) {
		sleep(1);	// penser
		sem_wait(&mutex);	// essayer de prendre les fourchettes pour manger
		if (fourch[G] == libre && fourch[D] == libre) {
			fourch[G] = occupe;
			fourch[D] = occupe;
			sem_post(&mutex);
			nb--;
			printf("philosophe[%d] mange\n", i);
			sleep(1);	// manger
			printf("philosophe[%d] a fini de manger\n", i);
			sem_wait(&mutex);	// libérer les fourchettes
			fourch[G] = libre;
			fourch[D] = libre;
			sem_post(&mutex);
		} else
			sem_post(&mutex);
	}
	return NULL;
}

int main()
{
	int i, NumPhi[N];
	for (i = 0; i < N; i++)
		NumPhi[i] = i;
	for (i = 0; i < N; i++)
		fourch[i] = libre;
	pthread_t th[N];
	sem_init(&mutex, 0, 1);
	// création des N philosophes
	for (i = 0; i < N; i++)
		pthread_create(&th[i], NULL, philosophe, &NumPhi[i]);
	// attendre la fin des threads
	for (i = 0; i < N; i++)
		pthread_join(th[i], NULL);
	printf("fin des threads\n");
	return 0;
}
